import junit.framework.*;

public class FrameTest extends TestCase
{
    protected void setUp()
    {
    }

    public void testSingleOpenFrame()
    {
        Frame open = new Frame();
        open.roll( 4 );
        open.roll( 2 );
        assertEquals( 6, open.score() );
    }

    public void testTwoOpenFrames()
    {
        Frame open = new Frame();
        open.roll( 4 );
        open.roll( 2 );
        open.roll( 3 );
        open.roll( 5 );
        assertEquals( 6, open.score() );
    }

    public void testScoreTwoOpenFrames()
    {
        Frame open = new Frame();
        open.roll( 4 );
        open.roll( 2 );
        open.roll( 3 );
        open.roll( 5 );
        assertEquals( 6, open.score() );
        assertEquals( 14, open.gameScore() );
    }

    public void testScoreThreeOpenFrames()
    {
        Frame open = new Frame();
        open.roll( 4 );
        open.roll( 2 );
        open.roll( 3 );
        open.roll( 5 );
        open.roll( 2 );
        open.roll( 2 );
        assertEquals( 18, open.gameScore() );
    }

    public void testAllGutterBalls()
    {
        Frame open = new Frame();
        for (int i = 0; i < 20; i++)
            open.roll( 0 );
        assertEquals( "all gutter balls gives a score of 0",
                      0, open.gameScore() );
    }

    public void testAllOpenFrames()
    {
        Frame open = new Frame();
        for (int i = 0; i < 10; i++)
        {
            open.roll( 5 );
            open.roll( 4 );
        }
        assertEquals( "ten frames of 9 give a score of 90",
                      90, open.gameScore() );
    }

    public static Test suite()
    {
        return new TestSuite( FrameTest.class );
    }

    public static void main( String[] args )
    {
        junit.textui.TestRunner.run( suite() );
    }
}
